// Define Our Gadget IDs

#define InfoGad       1
#define DestFileGad   2
#define DestDiskGad   3
#define ConvertGad    4
#define CalculateGad  5
#define Check1Gad     6
#define Check2Gad     7
#define Check3Gad     8
#define Check4Gad     9
#define Check5Gad     10
#define Check6Gad     11
#define Check7Gad     12
#define Check8Gad     13
#define File1Gad      14
#define File2Gad      15
#define File3Gad      16
#define File4Gad      17
#define File5Gad      18
#define File6Gad      19
#define File7Gad      20
#define File8Gad      21
#define Disk1Gad      22
#define Disk2Gad      23
#define Disk3Gad      24
#define Disk4Gad      25
#define Disk5Gad      26
#define Disk6Gad      27
#define Disk7Gad      28
#define Disk8Gad      29
#define Chan11Gad     30
#define Chan12Gad     31
#define Chan13Gad     32
#define Chan14Gad     33
#define Chan15Gad     34
#define Chan16Gad     35
#define Chan17Gad     36
#define Chan18Gad     37
#define Chan21Gad     38
#define Chan22Gad     39
#define Chan23Gad     40
#define Chan24Gad     41
#define Chan25Gad     42
#define Chan26Gad     43
#define Chan27Gad     44
#define Chan28Gad     45
#define Chan31Gad     46
#define Chan32Gad     47
#define Chan33Gad     48
#define Chan34Gad     49
#define Chan35Gad     50
#define Chan36Gad     51
#define Chan37Gad     52
#define Chan38Gad     53
#define Chan41Gad     54
#define Chan42Gad     55
#define Chan43Gad     56
#define Chan44Gad     57
#define Chan45Gad     58
#define Chan46Gad     59
#define Chan47Gad     60
#define Chan48Gad     61
#define Loop1Gad      62
#define Loop2Gad      63
#define Loop3Gad      64
#define Loop4Gad      65
#define Loop5Gad      66
#define Loop6Gad      67
#define Loop7Gad      68
#define Loop8Gad      69

#define MaxGadgets    69

// Tracker Marks
#define m_k_          0x4d2e4b2e
#define M_K_          0x4d214b21
#define m_K_          0x4d264b21
#define xchn          0x0043484e
#define xxch          0x00004348

// Other Defines
#define CHECKBOXWIDTH   26
#define CHECKBOXHEIGHT  11

#define DISKWIDTH       23
#define DISKHEIGHT      14

#define our_idcmp IDCMP_CLOSEWINDOW | IDCMP_MENUPICK | IDCMP_REFRESHWINDOW | CHECKBOXIDCMP | BUTTONIDCMP | STRINGIDCMP | CYCLEIDCMP
#define abo_idcmp IDCMP_MOUSEBUTTONS | IDCMP_VANILLAKEY

// Define Protracker module format structures

typedef struct Sample
  {
    char    Name[22];
    UWORD   Length;
    UBYTE   Finetune;
    UBYTE   Volume;
    UWORD   Repeat;
    UWORD   RepeatLength;
  } SAMPLE;

typedef struct Module
  {
    char    SongName[20];
    SAMPLE  Samples[31];
    UBYTE   SongLength;
    UBYTE   Pad;
    UBYTE   Positions[128];
    ULONG   Mark;
  } MODULE;

typedef struct Channel
  {
    ULONG   SampleHi  : 4;
    ULONG   Note      : 12;
    ULONG   SampleLow : 4;
    ULONG   Effect    : 4;
    ULONG   EffectArg : 8;
  } CHANNEL;


// Define Disk Image

UWORD __chip Disk_Norm[4*14] =
  {
    // Plane 1
    0x0000, 0x0200, 0x0000, 0x0600, 0x0c00, 0x6600, 0x0df7, 0x7600,
    0x0c00, 0x7600, 0x0ddf, 0x7600, 0x0c00, 0x7600, 0x0fff, 0xf600,
    0x0e00, 0xf600, 0x0e00, 0xf600, 0x0600, 0xf600, 0x03ff, 0xf600,
    0x0000, 0x0600, 0x7fff, 0xfe00,

    // Plane 2
    0xffff, 0xfc00, 0xc000, 0x0000, 0xcfff, 0xe000, 0xce08, 0xe000,
    0xcfff, 0xe000, 0xce20, 0xe000, 0xcfff, 0xe000, 0xcfff, 0xe000,
    0xcfff, 0xe000, 0xcf9f, 0xe000, 0xc79f, 0xe000, 0xc000, 0x0000,
    0xc000, 0x0000, 0x8000, 0x0000
  };

UWORD __chip Disk_Pres[4*14] =
  {
    // Plane 1
    0xffff, 0xfc00, 0xc000, 0x0000, 0xcc00, 0x6000, 0xcdf7, 0x7000,
    0xcc00, 0x7000, 0xcddf, 0x7000, 0xcc00, 0x7000, 0xcfff, 0xf000,
    0xcf00, 0x7000, 0xcf30, 0x7000, 0xc730, 0x7000, 0xc3ff, 0xf000,
    0xc000, 0x0000, 0x8000, 0x0000,

    // Plane 2
    0x0000, 0x0200, 0x0000, 0x0600, 0x0fff, 0xe600, 0x0e08, 0xe600,
    0x0fff, 0xe600, 0x0e20, 0xe600, 0x0fff, 0xe600, 0x0fff, 0xe600,
    0x0fff, 0xe600, 0x0fcf, 0xe600, 0x07cf, 0xe600, 0x0000, 0x0600,
    0x0000, 0x0600, 0x7fff, 0xfe00
  };

// Define about image

UWORD __chip AboutImage[] =
  {
    // Plane 1
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x7FFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xA000,0x7FFF,0x7555,0x5510,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,
    0xAAAA,0xAAAA,0xAAA8,0x8888,0x8004,0xA000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FDD,0xDDDD,0x5444,0x4400,
    0x0000,0x003F,0xFF80,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x6AAA,0xAAAA,0xAAAA,0xAAAA,0xA200,0x01FB,0xAB80,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x7FF7,0xF755,
    0x5551,0x0000,0x0000,0x07FF,0xFFE0,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAAA,0xAAAA,0x8888,
    0x8FEE,0xEEE8,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,
    0x7FDD,0xDDD5,0x4444,0x4000,0x0000,0x1FFF,0xFFF8,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAAA,
    0xAAAA,0xAA20,0x3FFF,0xBAAA,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0x7555,0x5510,0x0000,0x0000,0xFFFF,
    0xFFFE,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,
    0xAAAA,0xAAAA,0xAAA8,0x8888,0xFFEE,0xEEEE,0x8000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FDD,0xDDDD,0x5444,0x4400,
    0x0001,0xFFFF,0xFFFF,0x8000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x6AAA,0xAAAA,0xAAAA,0xAAAA,0xA203,0xFFFB,0xFBAA,
    0x8000,0x0000,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xF755,
    0x5551,0x0000,0x0007,0xFFFE,0xBFFF,0xC000,0x0000,0x0000,
    0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAAA,0xAAAA,0x888F,
    0xFFE0,0x0EEA,0x8000,0x0000,0x0000,0x0000,0x0000,0x2000,
    0x7FDD,0xDDD5,0x4444,0x404F,0x4007,0xFFE0,0x0FFF,0xC000,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAAA,
    0xAAFF,0xFA27,0xFF80,0x02AA,0xA000,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0x7555,0x5511,0x03FF,0xF807,0xFF80,
    0x07FF,0xE000,0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,
    0xAAAA,0xAAAA,0xBFFF,0xFE8F,0xFF80,0x02EE,0xA000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FDD,0xDDDD,0x5444,0xFFFF,
    0xFE0F,0xFF80,0x03FF,0xE000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x6AAA,0xAAAA,0xAAAB,0xFFFF,0xFE8F,0xFF80,0x03AA,
    0xA000,0x0000,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xF755,
    0x555F,0xFFFF,0xFF8F,0xFF80,0x01FF,0xF000,0x0000,0x0000,
    0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAFF,0xFFFF,0xFF8F,
    0xFF80,0x02EA,0xE000,0x0000,0x0000,0x0000,0x0000,0x2000,
    0x7FDD,0xDDD5,0x44FF,0xFFFF,0xFFCF,0xFFC0,0x03FF,0xE000,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,0xAAAA,0xAAFF,
    0xFFFF,0xFFAF,0xFFC0,0x03AA,0xA000,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0x7555,0x55FF,0xFE0F,0xFF8F,0xFFC0,
    0x03FF,0xC000,0x0000,0x0000,0x0000,0x0000,0x2000,0x6AAA,
    0xAAAE,0xAAFF,0xFEAF,0xFFCF,0xFFF0,0x0EEE,0x8000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FFD,0xDDFF,0xF47F,0xFE07,
    0xFFC7,0xFFF0,0x0FFF,0xE000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x6AAA,0xAAFF,0xFAFF,0xFEAB,0xFFA3,0xFFFF,0xFBAA,
    0xAA80,0x0000,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xF7FF,
    0xFD7F,0xFF03,0xFFC7,0xFFFF,0xFFFF,0xFFFC,0x0000,0x0000,
    0x0000,0x0000,0x2000,0x6AAA,0xBFFF,0xFEBF,0xFFAB,0xFFFF,
    0xFFEE,0xEEEE,0xEAAA,0x0000,0x0000,0x0000,0x0000,0x2000,
    0x7FDD,0xFFFF,0xFF7F,0xFF47,0xFFFF,0xFFFF,0xFFFF,0xFFDD,
    0xC000,0x0000,0x0000,0x0000,0x2000,0x6AAF,0xFFFF,0xFFBF,
    0xFFAF,0xFFFF,0xFFFF,0xFBBA,0xAAAA,0xA000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0xFFFF,0xFFDF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xF400,0x0000,0x0000,0x0000,0x2000,0x6BFF,
    0xFFFF,0xFFBF,0xFFFF,0xFFFF,0xFFFE,0xEEEE,0xEAAA,0xAA00,
    0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFFF,0xFFCF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFD,0xDC00,0x0000,0x0000,0x0000,
    0x2000,0x6AFF,0xFFBF,0xFFEF,0xFFFF,0xFFFF,0xFFFF,0xFB83,
    0xAAAA,0xAA00,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFF57,
    0xFFD7,0xFFFF,0xFFFF,0xFFFF,0xFF80,0x0FFF,0xF700,0x0000,
    0x0000,0x0000,0x2000,0x6AFF,0xFEAF,0xFFEF,0xFFFF,0xFFFC,
    0x88FF,0xEC00,0x00AA,0xAA80,0x0000,0x0000,0x0000,0x2000,
    0x7FFF,0xFFDF,0xFFFF,0xFFFF,0xFFF8,0x001B,0x2000,0x00DF,
    0xDD80,0x0000,0x0000,0x0000,0x2000,0x6AFF,0xFEAB,0xFFBF,
    0xFFFF,0xFFFE,0x2000,0x0000,0x00AA,0xAA80,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0xFF77,0xFFDF,0xFFFF,0xFFFE,0x0000,
    0x0000,0x01FF,0xFF00,0x0000,0x0000,0x0000,0x2000,0x6EBF,
    0xFFAF,0xFFAF,0xFFFF,0xFFFF,0x8880,0x0000,0x02AA,0xAA00,
    0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFDF,0xFFC7,0xFFFC,
    0xFFFF,0x8000,0x0000,0x07FF,0xDC00,0x0000,0x0000,0x0000,
    0x2000,0x6ABF,0xFFBF,0xFFAB,0xFFFA,0xFFFF,0xC000,0x0000,
    0x0AAA,0xA800,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFFF,
    0xFF55,0xFFF8,0x1FFF,0x0000,0x0000,0x7FFF,0xF800,0x0000,
    0x0000,0x0000,0x2000,0x6AAF,0xFFFF,0xFEAA,0xFFFE,0xBFF8,
    0x8880,0x0000,0xEEEA,0xA000,0x0000,0x0000,0x0000,0x2000,
    0x7FFF,0xFFFF,0xFD44,0xFFFC,0x5FC0,0x0000,0x0003,0xFFFF,
    0xC000,0x0000,0x0000,0x0000,0x2000,0x6AAF,0xFFFF,0xFAAA,
    0xFFFE,0xAFAA,0x2000,0x000B,0xBAAA,0x8000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0xFFFF,0xD555,0x7FFE,0x0000,0x0000,
    0x003F,0xFFFE,0x0000,0x0000,0x0000,0x0000,0x2000,0x6EAF,
    0xFFFE,0xAAAA,0xFFFE,0xA888,0x8888,0x00EE,0xEEE8,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFFD,0xDD54,0x7FFE,
    0x0000,0x0000,0x07FF,0xFFF0,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x6AAB,0xFFFA,0xAAAA,0xBFFA,0xAAAA,0xA200,0x1FFB,
    0xAB80,0x0000,0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFF7,
    0x5555,0x7FC0,0x0000,0x0000,0x7FFF,0xFF00,0x05F4,0x0000,
    0x0000,0x0000,0x2000,0x6EEB,0xFFFA,0xAAAA,0xBEBF,0xFFFF,
    0x888B,0xFFEE,0xEC00,0x0AAA,0x80AA,0xAAAA,0xAA00,0x2000,
    0x7FFF,0xFFFD,0xD544,0x445F,0xFFFF,0x800F,0xFFFF,0xF000,
    0x7FDD,0xC0DD,0xDDD5,0xD500,0x2000,0x7AAB,0xFFFA,0xAAAA,
    0xAABF,0xFFFF,0xA27F,0xFFFF,0x8000,0xAAAA,0xA0AA,0xAAAA,
    0xAA00,0x2000,0x7FFF,0xFFFD,0x5555,0x511F,0xFFFF,0x81FF,
    0xFFFE,0x0001,0xFFFF,0xE077,0x7555,0x5500,0x2000,0x6EAA,
    0xFFFE,0xAAAA,0xAABF,0xFFFF,0x8FFF,0xFFE8,0x0000,0xEAAA,
    0xA0AA,0xAAAA,0xAA00,0x2000,0x7FFF,0xFFFD,0xDD54,0x445F,
    0xFFFF,0x8FFF,0xFFF0,0x0003,0xFE01,0xDDDD,0xDDDD,0xDD00,
    0x2000,0x6AAA,0xFFFE,0xAAAA,0xAABF,0xAAAA,0xAFFF,0xFFF0,
    0x0002,0xA802,0xAAAA,0xAAAA,0xA000,0x2000,0x7FFF,0xFFFF,
    0x5555,0x511F,0x8000,0x0FFF,0xFFF0,0x0007,0xF9FF,0xFFF7,
    0xF757,0x4000,0x2000,0x6EEA,0xFFFE,0xAAAA,0xAABF,0xAAFF,
    0xFFFF,0xFFE8,0x0006,0xEAEA,0xAAAA,0xAAAA,0xA000,0x2000,
    0x7FFF,0xFFFD,0xDDD5,0x445F,0xC3FF,0xFFFF,0xFFF8,0x001F,
    0xFFFF,0xDFDD,0xDDDD,0xC000,0x2000,0x7AAA,0xBFEA,0xAAAA,
    0xAABF,0xAFFF,0xFFFC,0xFCFC,0x07BA,0xAAAA,0xAAAA,0xAAAA,
    0x8000,0x2000,0x7FFF,0xFFF7,0x7555,0x551F,0x8FFF,0xFFF0,
    0xFCFD,0xFFFF,0xFFFF,0xFFFF,0xFF74,0x0000,0x2000,0x6EEE,
    0xBEAA,0xAAAA,0xAABF,0xAFFF,0xFF89,0xFCFE,0xEEEE,0xEEEA,
    0xAAAA,0xAAA0,0x0000,0x2000,0x7FFF,0xFDDD,0xDDD5,0x447F,
    0xCFFF,0xFE01,0xFCFF,0xFFFF,0xFFFF,0xFFFD,0x05C0,0x0000,
    0x2000,0x7BAA,0xAAAA,0xAAAA,0xAFFF,0xAFFF,0xFAAF,0xF8FF,
    0xFFFB,0xABAA,0xAA80,0x02A0,0x0000,0x2000,0x7FFF,0xFFF7,
    0x5755,0x7FFF,0x8FFF,0x83FF,0xF1FF,0xFFFF,0xFFFF,0xC000,
    0x07E0,0x0000,0x2000,0x6EEA,0xAAAA,0xAAAA,0xBFFF,0xAFFE,
    0xFFFF,0xF9FF,0xEEEE,0xEEE0,0x0000,0x02A0,0x0000,0x2000,
    0x7FFF,0xFFDD,0xDDD5,0x7FFF,0xFFFF,0xFFFF,0xE3FF,0xFFFF,
    0xFFE0,0x0000,0x07C0,0x0000,0x2000,0x7AAA,0xAAAA,0xAAAA,
    0xBFFF,0xFFFF,0xFFFF,0xE3FF,0xFFF8,0x3AA8,0x0000,0x02A0,
    0x0000,0x2000,0x7FFF,0xFFFF,0x7555,0x7FFF,0xFFFF,0x8FFF,
    0xE3FF,0xFC00,0x1FFC,0x0000,0x07E0,0x0000,0x2000,0x6EEE,
    0xAAAA,0xAAAA,0xBFFF,0xFFFF,0xAFFF,0xCFFF,0xC000,0x0EEE,
    0x0000,0x02A0,0x0000,0x2000,0x7FFF,0xFFDD,0xDDDD,0x7FFF,
    0xFFFF,0x8FFF,0xC60F,0xC000,0x03FF,0x8000,0x07E0,0x0000,
    0x2000,0x7BAA,0xAAAA,0xAAAA,0xBFFF,0xFFFF,0xAFFF,0xA207,
    0xE000,0x01AB,0x8000,0x02A0,0x0000,0x2000,0x7FFF,0xFFFF,
    0xF755,0x7FFF,0x8100,0x0F9F,0xFFFF,0xE000,0x007F,0xE000,
    0x07E0,0x0000,0x2000,0x6EEE,0xEAAA,0xAAAA,0xBFFF,0xAAAA,
    0xAABF,0xFFFF,0xF000,0x002E,0xE000,0x02A0,0x0000,0x2000,
    0x7FFF,0xFFDD,0xDDDD,0xFFFF,0xCFE0,0x403F,0xFFFF,0xF000,
    0x000F,0xF000,0x07E0,0x0000,0x2000,0x7BBA,0xAAAA,0xAAAA,
    0xBFFF,0xAAAA,0xAAFF,0xFFFF,0xF800,0x0003,0xB000,0x02A0,
    0x0000,0x2000,0x7FFF,0xFFFF,0xF775,0x7FFF,0x9100,0x007F,
    0xFFFF,0xF800,0x0007,0xF800,0x07E0,0x0000,0x2000,0x6EEE,
    0xEAAA,0xAAAA,0xBEBF,0xAAAA,0xAAFF,0xFFFF,0xF800,0x0002,
    0xE000,0x06A0,0x0000,0x2000,0x7FFF,0xFFFD,0xDDDD,0xD55F,
    0xC444,0x00FC,0x0000,0xFC00,0x0003,0xF800,0x07E0,0x0000,
    0x2000,0x7BAB,0xAAAA,0xAAAA,0xAABF,0xAAAA,0xAAFE,0xA202,
    0xFC00,0x0003,0xF800,0x02A0,0x0000,0x2000,0x7FFF,0xFFFF,
    0xF757,0x555F,0xD100,0x01F8,0x0000,0x7E04,0x0003,0xF000,
    0x07E0,0x0000,0x2000,0x6EEE,0xEAAA,0xAAAA,0xAABF,0xAAAA,
    0xABFA,0x8888,0xFE86,0x0006,0xE800,0x06E0,0x0000,0x2000,
    0x7FFF,0xFFFF,0xDDDD,0xD55F,0xC444,0x43F8,0x0000,0x7F07,
    0x0007,0xF000,0x07E0,0x0000,0x2000,0x7FBA,0xAAAA,0xAAAA,
    0xAABF,0xAAAA,0xABFA,0xAA22,0x3F07,0xC00F,0xF000,0x02A0,
    0x0000,0x2000,0x7FFF,0xFFFF,0xFF75,0x555F,0xD510,0x03F0,
    0x0000,0x3F07,0xF03F,0xE000,0x07E0,0x0000,0x2000,0x6EEE,
    0xEEAA,0xAAAA,0xAABF,0xAAAA,0xAFEA,0x8888,0x9F8F,0xFFFE,
    0xE000,0x06E0,0x0000,0x2000,0x7FFF,0xFFFF,0xDDDD,0xDD5F,
    0xC444,0x47E0,0x0000,0x1F87,0xFFFF,0xC000,0x07E0,0x0000,
    0x2000,0x7FFB,0xAAAA,0xAAAA,0xAABF,0xAAAA,0xAFEA,0xAAA2,
    0x2FC7,0xFFFF,0x8000,0x03A0,0x0000,0x2000,0x7FFF,0xFFFF,
    0xFFF7,0x555F,0xD551,0x0FC0,0x0000,0x0FC1,0xFFFF,0x0000,
    0x07E0,0x0000,0x2000,0x6EEE,0xEEEA,0xAAAA,0xAABF,0xAAAA,
    0xBFEA,0x8A88,0x8FE8,0xFFFC,0x0000,0x06E0,0x0000,0x2000,
    0x7FFF,0xFFFF,0xDDDD,0xDDDF,0xC444,0x5FC0,0x0000,0x07E0,
    0x0BD0,0x0000,0x07E0,0x0000,0x2000,0x7FFB,0xBAAA,0xAAAA,
    0xAAAA,0xAAAA,0xAAAA,0xAAAA,0x2220,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x7FFF,0xFFFF,0xFFF7,0x7555,0x5555,0x1000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x7EEE,
    0xEEEA,0xAAAA,0xAAAA,0xAAAA,0xAAAA,0xAAA8,0x8888,0x8888,
    0x0000,0x0000,0x0000,0x2000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x7FFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xE000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x7FFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xE000,0x4000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x4000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x4000,0x0000,0x0000,0x003F,
    0xF038,0x0000,0x0000,0x003E,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x4000,0x0033,0x0000,0x007F,0xF870,0x0000,0x0000,
    0x01FE,0x3800,0x0000,0x0000,0x0000,0x2000,0x40F0,0x0033,
    0x0000,0x007E,0x18F0,0x0000,0x0000,0x03FE,0xF800,0x0000,
    0x0000,0x0000,0x2000,0x41F0,0x0030,0x0000,0x0030,0x39E0,
    0x0000,0x0000,0x07DD,0xF800,0x0000,0x0000,0x0000,0x2000,
    0x4391,0xE1B3,0x361B,0x3000,0x73C0,0x0000,0x070E,0x061F,
    0xF000,0x0000,0x01C0,0x0000,0x2000,0x4303,0xF3F3,0x3F3F,
    0x3000,0xE783,0xC6F0,0x1F1E,0x003E,0xE1E3,0xB9BC,0x07C7,
    0x73B8,0x2000,0x4303,0x3333,0x3333,0x0001,0xC7F7,0xEFFE,
    0x773E,0x003D,0xC3E7,0x73FF,0x9DCF,0xF7F8,0x2000,0x4393,
    0x3333,0x3333,0x0003,0x8FEE,0xFFFE,0xEF76,0x0079,0xC7CF,
    0xE7FF,0xBBDF,0xEFF0,0x2000,0x41F3,0xF3F3,0x333F,0x3003,
    0x9FDD,0xFFFD,0xDEEE,0x0073,0x8F9D,0xCFFF,0x77BF,0xDFE0,
    0x2000,0x40F1,0xE1B3,0x331B,0x3007,0x9FFD,0xFFFF,0xFDFF,
    0x00E3,0xBE7F,0xFFFF,0xFF7F,0xBFD8,0x2000,0x4000,0x0000,
    0x0003,0x0007,0x1DFF,0xDBBF,0xFFFE,0x01E7,0x67EF,0xF6EF,
    0xFFFF,0xFFF8,0x2000,0x4000,0x0000,0x001E,0x000E,0x01C7,
    0x001C,0x6600,0x00C7,0xC380,0xC007,0x1981,0xC0E0,0x2000,
    0x4000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0007,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x4000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x4000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x4000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x4003,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x2000,0x4303,0x0000,0x0300,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x4303,0x0000,
    0x0300,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x2000,0x431B,0x1E1B,0x0600,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,
    0x433F,0x333F,0x0600,0x0000,0x0F00,0x00C0,0x0180,0x0380,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x4333,0x3F33,0x0C00,
    0x0000,0x3F00,0x03C0,0x0780,0x0780,0x0000,0x0000,0x0000,
    0x000C,0x2000,0x4333,0x3033,0x0C00,0x0000,0x7B00,0x0780,
    0x0F80,0x0F80,0x0000,0x0000,0x0000,0x001C,0x2000,0x433F,
    0x333F,0x1800,0x0000,0xF700,0x0F00,0x1F80,0x1F00,0x0000,
    0x0000,0x0000,0x0038,0x2000,0x431B,0x1E1B,0x1800,0x0001,
    0xC707,0x1E00,0x3E00,0x3E03,0x8000,0x0000,0xE073,0x0070,
    0x2000,0x4000,0x0000,0x0000,0x0303,0xCE1F,0x3F8F,0x3C00,
    0x7E0F,0x8EE7,0x8783,0xE1F7,0xE3F0,0x2000,0x4000,0x0000,
    0x0000,0x0303,0x8E77,0x3FDF,0xF800,0xEC3B,0x9FFF,0xDFCE,
    0xE773,0xE7E0,0x2000,0x4000,0x0000,0x6000,0x0003,0x9CEF,
    0x7FBB,0xF701,0xC077,0xBFFF,0xFFDD,0xEEF6,0xCFE0,0x2000,
    0x407C,0x0000,0x6000,0x0003,0x99DE,0xFF77,0xEE01,0x80EF,
    0x7FF7,0xF7BB,0xDDEF,0xDDC0,0x2000,0x407E,0x0000,0x0000,
    0x0303,0x3DFD,0xFCF7,0xEF0F,0x80FE,0xFF7F,0xFFFF,0xBFDD,
    0xFFD8,0x2000,0x4067,0x1E1C,0x6366,0xC300,0x70FF,0xEFFF,
    0xF81F,0xFC7F,0xFFFF,0xFFDF,0xFFF9,0xEFF0,0x2000,0x4063,
    0x3336,0x67E7,0xE001,0xE066,0x0F1C,0x703F,0xFE33,0x0387,
    0x070C,0xC660,0x06E0,0x2000,0x4063,0x3F3C,0x6666,0x6003,
    0x8000,0x0000,0x0000,0x0000,0x001E,0x1E00,0x0000,0x0000,
    0x2000,0x4067,0x301E,0x6666,0x600F,0x0000,0x0000,0x0000,
    0x0000,0x003C,0x3C00,0x0000,0x0000,0x2000,0x407E,0x3336,
    0x67E6,0x600F,0x0000,0x0000,0x0000,0x0000,0x0038,0x3800,
    0x0000,0x0000,0x2000,0x407C,0x1E1C,0x6366,0x601E,0x0000,
    0x0000,0x0000,0x0000,0x0070,0x7000,0x0000,0x0000,0x2000,
    0x4000,0x0000,0x0060,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x2000,0x4000,0x0000,0x03C0,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x2000,0x4000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x2000,0x4000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x2000,0x7FFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xE000,

    // Plane 2
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0008,0xAAAA,0xAEEF,0xFFFF,0xFFFF,0xC000,0x8000,
    0x0000,0x0000,0x0000,0x0000,0x0111,0x1115,0x5555,0x5555,
    0x5555,0x5577,0x7777,0xC000,0x8000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0222,0x22AB,0xBBBB,0xFFFF,0xFFFF,
    0xC000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0004,0x547D,
    0x5555,0x5555,0x5555,0x5555,0x5DFF,0xC000,0x8000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x001E,0x0008,0xAAAA,0xAEFF,
    0xFFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,0x0000,0x0000,
    0x0011,0x1117,0x5555,0x5555,0x5555,0x5577,0x7777,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0007,0xE222,
    0x223A,0xBBBB,0xBFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x4555,0xD555,0x5555,0x5555,0x5555,
    0xDDFF,0xC000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0001,0xF008,0xAAAA,0xAAEF,0xFFFF,0xFFFF,0xC000,0x8000,
    0x0000,0x0000,0x0000,0x0000,0x0011,0x1111,0x7555,0x5555,
    0x5555,0x5557,0x7777,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x7E22,0x22AB,0xBBBB,0xBFFF,0xFFFF,
    0xC000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0004,0x0455,
    0x7D55,0x5555,0x5555,0x5555,0x5DDD,0xC000,0x8000,0x0000,
    0x0000,0x0000,0x0000,0x0001,0x4000,0x3C08,0xAAAA,0xAEFE,
    0xFFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,0x0000,0x0000,
    0x001F,0xF115,0x7F55,0x5555,0x5555,0x5575,0x7777,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0000,0x001F,0x8000,0x3E22,
    0x222A,0xBBBB,0xBFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x007F,0x4555,0x5F55,0x5555,0x5555,0x5555,
    0x55DD,0xC000,0x8000,0x0000,0x0000,0x0000,0x0780,0x007C,
    0x0000,0x1F08,0x8AAA,0xAAEF,0xFFFF,0xFFFF,0xC000,0x8000,
    0x0000,0x0000,0x0000,0x0140,0x007D,0x1111,0x5F55,0x5555,
    0x5555,0x5555,0x7777,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x01F0,0x007C,0x0000,0x1FA2,0x222A,0xBBBB,0xBBFF,0xFFFF,
    0xC000,0x8000,0x0000,0x0000,0x0000,0x0170,0x007C,0x0455,
    0x5F55,0x5555,0x5555,0x5555,0x5555,0x4000,0x8000,0x0000,
    0x0000,0x0000,0x0070,0x007C,0x0000,0x0F08,0xAAAA,0xAAAE,
    0xFFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,0x0000,0x0070,
    0x007D,0x1115,0x1FD5,0x5555,0x5555,0x5555,0x7575,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0030,0x003C,0x0000,0x1F22,
    0x222A,0xBBBB,0xBBBF,0xFFFF,0xC000,0x8000,0x0000,0x0000,
    0x0000,0x0050,0x003E,0x4455,0x5F55,0x5555,0x5555,0x5555,
    0x5555,0x4000,0x8000,0x0000,0x0000,0x01F0,0x0070,0x003E,
    0x0000,0x3F00,0x8AAA,0xAAAE,0xEFFF,0xFFFF,0xC000,0x8000,
    0x0000,0x0000,0x0150,0x0030,0x000F,0x1111,0x7F55,0x5555,
    0x5555,0x5555,0x5555,0x4000,0x8000,0x0000,0x0000,0x01E0,
    0x0038,0x000F,0x8000,0x1E22,0x2222,0xABBB,0xBBBB,0xFFFF,
    0xC000,0x8000,0x0000,0x0500,0x0150,0x005C,0x0000,0x0455,
    0x5555,0x5555,0x5555,0x5555,0x5555,0x4000,0x8000,0x0000,
    0x0280,0x00F0,0x0038,0x07FF,0xFFFF,0xFFC0,0x08AA,0xAAAE,
    0xAEFF,0xFFFF,0xC000,0x8000,0x0000,0x0140,0x0050,0x0007,
    0x7FFF,0xFFFF,0xFFFD,0x5555,0x5555,0x5555,0x5555,0x4000,
    0x8000,0x0000,0x0080,0x00B8,0x01FF,0xFFFF,0xFFFF,0xFFFF,
    0x2222,0x2ABB,0xBBBB,0xBFBF,0xC000,0x8000,0x0000,0x0040,
    0x0050,0x15DF,0xFFFF,0xFFFF,0xFFFF,0xF555,0x5555,0x5555,
    0x5555,0x4000,0x8000,0x0000,0x0020,0x0003,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xF8AA,0xAAAA,0xAEEF,0xFFFF,0xC000,0x8000,
    0x0000,0x0040,0x0015,0x5777,0x77FF,0xFFFF,0xFFFF,0xFD55,
    0x5555,0x5555,0x5555,0x4000,0x8000,0x0000,0x0030,0x01BF,
    0xFFFF,0xFFFC,0x0003,0xFFFF,0xFE22,0x2AAB,0xBBBB,0xBBBB,
    0xC000,0x8000,0x0040,0x0010,0x0555,0x555D,0xF800,0x047C,
    0x5FFF,0xFF55,0x5555,0x5555,0x5555,0x4000,0x8000,0x00A8,
    0x0028,0x7FFF,0xFFFC,0x0000,0x007E,0x01FF,0xFFA8,0xAAAA,
    0xAEAE,0xFEFE,0xC000,0x8000,0x0140,0x0011,0x5555,0x7702,
    0x0000,0x13FD,0x15FF,0xFF55,0x5555,0x5555,0x5555,0x4000,
    0x8000,0x0020,0x000B,0xBBBF,0xF807,0x8004,0xDFE0,0x007F,
    0xFF22,0x2A2A,0xBBBB,0xBBBB,0xC000,0x8000,0x0150,0x0045,
    0x5555,0x0001,0xC000,0xD945,0x557F,0xFF55,0x5555,0x5555,
    0x5555,0x4000,0x8000,0x0080,0x0022,0xEFFC,0x0001,0xE000,
    0x0000,0x00FF,0xFF8A,0xAAAA,0xAAAA,0xEEEE,0xC000,0x8000,
    0x0050,0x0051,0x5540,0x0000,0x7000,0x1111,0x11FF,0xFF55,
    0x5555,0x5555,0x5555,0x4000,0x8000,0x0020,0x0039,0xBB03,
    0x0000,0x7C00,0x0000,0x03FF,0xFE22,0x222A,0xABBB,0xBBBB,
    0xC000,0x8000,0x0040,0x0054,0x5005,0x0000,0x3C00,0x0004,
    0x57FF,0xFD55,0x5555,0x5555,0x5555,0x4000,0x8000,0x0000,
    0x00A8,0x2007,0xC000,0xFE00,0x0000,0x1FFF,0xE008,0xAAAA,
    0xAAAA,0xAEAE,0xC000,0x8000,0x0000,0x0150,0x0001,0x4007,
    0x7000,0x1111,0x7FFF,0xD555,0x5555,0x5555,0x5555,0x4000,
    0x8000,0x0000,0x02B0,0x0003,0xA03F,0xC000,0x0000,0xFFFF,
    0xA222,0x222A,0x2ABA,0xBBBB,0xC000,0x8000,0x0000,0x0540,
    0x0001,0x4054,0x0000,0x0007,0xFFFF,0x5555,0x5555,0x5555,
    0x5555,0x4000,0x8000,0x0000,0x2A80,0x0001,0xE038,0x0000,
    0x000F,0xFFF8,0x0000,0x8AAA,0xAAAA,0xAAAA,0xC000,0x8000,
    0x0001,0x5400,0x0001,0x5000,0x0000,0x013F,0xFFF1,0x5555,
    0x5555,0x5555,0x5555,0x4000,0x8000,0x0002,0x2000,0x0001,
    0xF000,0x0000,0x00FF,0xFFC0,0x0222,0x2222,0x22AA,0xABAB,
    0xC000,0x8000,0x0005,0x0000,0x0005,0x5000,0x0000,0x07FF,
    0xFF55,0x5555,0x5555,0x5555,0x5555,0x4000,0x8000,0x0008,
    0x8000,0x003F,0x8000,0x0000,0x187F,0xFC00,0x0000,0x08A8,
    0xAAAA,0xAAAA,0xC000,0x8000,0x0005,0x0000,0x0140,0x0000,
    0x0000,0x787F,0xF115,0x1555,0x5555,0x5555,0x5555,0x4000,
    0x8000,0x0002,0x0000,0x00A0,0x0000,0x0003,0xF03F,0x8000,
    0x0022,0x2222,0x222A,0x3A2A,0xC000,0x8000,0x0005,0x4000,
    0x0000,0x0000,0x500F,0xF03E,0x4455,0x5555,0x5555,0x555F,
    0xF5F5,0x4000,0x8000,0x0002,0x8000,0x0000,0x0000,0x707F,
    0xE018,0x0000,0x0000,0x1C88,0x8BFF,0xFAEA,0xC000,0x8000,
    0x0001,0x4000,0x0000,0x0000,0x7177,0x6011,0x1111,0x1555,
    0x5D55,0xFFFF,0xF5F5,0x4000,0x8000,0x0002,0x2000,0x0000,
    0x0000,0x7FFF,0xC00C,0x0000,0x01FE,0x223F,0xFFFF,0xE2E2,
    0x4000,0x8000,0x0001,0x4000,0x0000,0x5555,0x5DFF,0xC00C,
    0x0455,0x57FD,0x5FFF,0xFFFF,0xFFF5,0x4000,0x8000,0x0000,
    0xA000,0x0000,0x7FFF,0xFFFF,0xC00E,0x0000,0x0607,0xDFFF,
    0xFFFF,0xFFEA,0xC000,0x8000,0x0001,0x5000,0x0000,0x5005,
    0x7777,0x0016,0x1111,0x15FF,0xFFFF,0xFFFF,0xD555,0x4000,
    0x8000,0x0002,0x2000,0x0000,0x307F,0xFFFC,0x0006,0x0000,
    0x7FFF,0xFFFF,0xFFFF,0xA222,0x4000,0x8000,0x0015,0x4000,
    0x0000,0x5155,0x55D0,0x0303,0x005F,0xFFFF,0xFFFF,0xFFFD,
    0x5555,0x4000,0x8000,0x0008,0x0000,0x0000,0x7FFF,0xFF80,
    0x0302,0x07FF,0xFFFF,0xFFFF,0xFE88,0x888A,0xC000,0x8000,
    0x0154,0x0000,0x0000,0x5557,0x7600,0x0301,0xFFFF,0xFFFF,
    0xFFFF,0x555D,0x5555,0x4000,0x8000,0x0020,0x0000,0x0000,
    0x3BFF,0xF000,0x033F,0xFFFF,0xFFFF,0xFF82,0x223E,0x2222,
    0x4000,0x8000,0x0000,0x0000,0x0040,0x5555,0x0000,0x07FF,
    0xFFFF,0xFFFF,0xD555,0x555D,0x5555,0x4000,0x8000,0x0000,
    0x0000,0x02A0,0x7FFC,0x000C,0x0FFF,0xFFFF,0xFFE0,0x0000,
    0x001C,0x0808,0x4000,0x8000,0x0000,0x0000,0x1540,0x5540,
    0x0374,0x077F,0xFFFF,0xF115,0x1555,0x555D,0x5555,0x4000,
    0x8000,0x0000,0x0000,0x1BA0,0x0000,0x7FF8,0x1FFF,0xFFF8,
    0x0000,0x0000,0x203E,0x2222,0x4000,0x8000,0x0000,0x0000,
    0x1540,0x0000,0x5558,0x1FFF,0xFC00,0x4555,0x5555,0x555D,
    0x5555,0x4000,0x8000,0x0000,0x0000,0x0AA0,0x0000,0x7FF0,
    0x1FF8,0x0000,0x0000,0x0000,0x001C,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x1540,0x0000,0x5770,0x3600,0x3111,0x1111,
    0x1155,0x555D,0x5555,0x4000,0x8000,0x0000,0x0000,0x0BA0,
    0x0000,0x7FF0,0x3800,0x3800,0x0000,0x0000,0x001E,0x2222,
    0x4000,0x8000,0x0000,0x0000,0x1540,0x0000,0x5500,0x5800,
    0x1800,0x0454,0x7555,0x555D,0x5555,0x4000,0x8000,0x0000,
    0x0000,0x0AA0,0x7EFF,0xF000,0x0000,0x1800,0x0000,0x1000,
    0x001C,0x0000,0x4000,0x8000,0x0000,0x0000,0x1540,0x5555,
    0x5000,0x0000,0x0C11,0x1111,0x1915,0x155D,0x5555,0x4000,
    0x8000,0x0000,0x0000,0x0AA0,0x3000,0x0000,0x0000,0x0C00,
    0x0000,0x0C00,0x001C,0x0020,0x4000,0x8000,0x0000,0x0000,
    0x1540,0x5000,0x0000,0x0000,0x0600,0x0044,0x4D55,0x555D,
    0x5555,0x4000,0x8000,0x0000,0x0000,0x0800,0x6000,0x0000,
    0x0000,0x0600,0x0000,0x0600,0x001C,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x5000,0x0000,0x0000,0x0701,0x1111,
    0x1F11,0x115D,0x5555,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x3000,0x0003,0xFFFF,0x0300,0x0000,0x0700,0x001C,0x0000,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x5000,0x0001,0x5DFD,
    0x0300,0x0004,0x0654,0x555D,0x5555,0x4000,0x8000,0x0000,
    0x0000,0x0000,0x2000,0x0007,0x8000,0x0180,0x0000,0x0F00,
    0x001C,0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x5000,
    0x0005,0x0000,0x0100,0x1011,0x1711,0x111D,0x1515,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x3000,0x0007,0x0000,0x00C0,
    0x8000,0x0E00,0x001C,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0000,0x5000,0x0005,0x0000,0x00C0,0x0000,0x0F44,0x455D,
    0x5555,0x4000,0x8000,0x0000,0x0000,0x0000,0x2000,0x000F,
    0x0000,0x00E0,0x0000,0x1E00,0x001C,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x5000,0x0014,0x0000,0x0060,0x0001,
    0x1F11,0x111D,0x1111,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x3000,0x001E,0x0000,0x0060,0x0000,0x3C00,0x001C,0x0000,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x5000,0x0014,0x0000,
    0x0030,0x0000,0x7C04,0x045C,0x5454,0x4000,0x8000,0x0000,
    0x0000,0x0000,0x2000,0x003C,0x0000,0x0030,0x0000,0xF800,
    0x001C,0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x5000,
    0x0010,0x0000,0x0010,0x0003,0xF011,0x111D,0x1111,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x3000,0x0038,0x0000,0x0018,
    0x342F,0xE000,0x001C,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0001,0x5000,0x0150,0x0000,0x01DC,0x0FFF,0x8000,0x00FC,
    0x4444,0x4000,0x8000,0x0000,0x0000,0x0002,0xA000,0x03F0,
    0x0000,0x00FC,0x017A,0x0000,0x00FC,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0001,0x1111,0x1111,0x4000,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xC000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xC000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x1008,0x0000,0x0000,0x0002,0x0000,0x0000,0x0000,0x0000,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x0810,0x0000,0x0000,
    0x0002,0x0800,0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,
    0x0000,0x0002,0x0810,0x0000,0x0000,0x0002,0x0800,0x0000,
    0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,0x0010,0x0820,
    0x0000,0x0000,0x0044,0x0800,0x0000,0x0000,0x0000,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x1040,0x0000,0x0102,0x0204,
    0x9000,0x0000,0x0040,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0000,0x2080,0x4210,0x0102,0x000A,0x2020,0x8884,0x0041,
    0x1088,0x4000,0x8000,0x0000,0x0000,0x0000,0x4110,0x2212,
    0x110A,0x0014,0x40A1,0x1084,0x8442,0x1108,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x8222,0x2402,0x2112,0x0008,0x4142,
    0x2100,0x8844,0x2210,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x8544,0x4204,0x4222,0x0010,0x8084,0x4081,0x1080,0x4020,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x8244,0x0224,0x4401,
    0x0020,0x9200,0x4089,0x1102,0x8148,0x4000,0x8000,0x0000,
    0x0000,0x0001,0x0410,0x4881,0x1082,0x0021,0x2022,0x1220,
    0x4424,0x1208,0x4000,0x8000,0x0000,0x0000,0x0002,0x0041,
    0x0004,0x2200,0x0040,0x4080,0x4001,0x0880,0x4020,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0001,
    0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0100,0x0040,0x0080,0x0080,
    0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0000,0x0100,0x0040,0x0080,0x0080,0x0000,0x0000,0x0000,
    0x0004,0x4000,0x8000,0x0000,0x0000,0x0000,0x0900,0x0080,
    0x0280,0x0080,0x0000,0x0000,0x0000,0x0004,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x1100,0x0100,0x0480,0x0100,0x0000,
    0x0000,0x0000,0x0008,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x4101,0x0200,0x0200,0x1200,0x8000,0x0000,0x2011,0x0010,
    0x4000,0x8000,0x0000,0x0000,0x0000,0x4201,0x0481,0x1400,
    0x1200,0x8220,0x8080,0x2010,0x2010,0x4000,0x8000,0x0000,
    0x0000,0x0000,0x8211,0x0040,0x8800,0x2408,0x8420,0x4042,
    0x2110,0x2020,0x4000,0x8000,0x0000,0x0000,0x0000,0x8421,
    0x1488,0x9100,0x4010,0x8844,0x4444,0x2212,0x4220,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x8842,0x2911,0x2200,0x8021,
    0x0090,0x9088,0x4422,0x4440,0x4000,0x8000,0x0000,0x0000,
    0x0001,0x0444,0x0410,0x2100,0x8022,0x0510,0x1008,0x8444,
    0x0448,0x4000,0x8000,0x0000,0x0000,0x0000,0x1010,0x2041,
    0x0800,0x0408,0x4804,0x4442,0x1108,0x2110,0x4000,0x8000,
    0x0000,0x0000,0x0000,0x2022,0x0104,0x1000,0x0211,0x0081,
    0x0104,0x4220,0x0220,0x4000,0x8000,0x0000,0x0000,0x0000,
    0x8000,0x0000,0x0000,0x0000,0x0002,0x0200,0x0000,0x0000,
    0x4000,0x8000,0x0000,0x0000,0x0001,0x0000,0x0000,0x0000,
    0x0000,0x0004,0x0400,0x0000,0x0000,0x4000,0x8000,0x0000,
    0x0000,0x0001,0x0000,0x0000,0x0000,0x0000,0x0008,0x0800,
    0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,0x0002,0x0000,
    0x0000,0x0000,0x0000,0x0010,0x1000,0x0000,0x0000,0x4000,
    0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x4000,0x8000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x4000,0x8000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x4000,0xBFFF,
    0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
    0xFFFF,0xFFFF,0xFFFF,0xC000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
  };
